
/**********************************************************************************************
    This file is part of PriiDash(TM), an enhanced instrument panel and
    data logger for the Prius and more. 
    Copyright (C) 2011 by TeamPrii at sourceforge.net

    PriiDash(TM) is provided "AS IS" under the terms of 
    the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version, WITH ADDITIONAL TERMS in 
    paragraphs below.

    This program is distributed in the hope that it will be useful,
    but Without Any Warranty; without even the implied warranty of
    Merchantability or Fitness For A Particular Purpose.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    ADDITIONAL TERMS
    
    IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY
    DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
    (INCLUDING, BUT NOT LIMITED TO, DEATH; INJURY; COLLISION AND/OR DAMAGE TO VEHICLES;
    LIABILITY FOR ACCIDENTS AND/OR TRAFFIC VIOLATIONS; PROCUREMENT OF SUBSTITUTE GOODS OR
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
    NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE OR
    INABILITY TO USE THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

    THE AUTHOR RESERVES ALL RIGHTS OF OWNERSHIP OF THE NAME OF THE SOFTWARE, PriiDash(TM).
    ALL MODIFIED VERSIONS MUST BE CLEARLY MARKED AS BEING DIFFERENT FROM THE ORIGINAL,
    AND MUST CARRY ACKNOWLEDGEMENT TO THE ORIGINAL AUTHOR, TeamPrii at sourceforge.net. 
    ALL ADVERTISING MATERIALS MENTIONING FEATURES OR USE OF THIS SOFTWARE
    MUST DISPLAY THE FOLLOWING ACKNOWLEDGEMENT:
    This product includes the software PriiDash(TM) developed by 
    TeamPrii at sourceforge.net.
    
    To contact the author: look up TeamPrii at sourceforge.net.
    Project home page: http://priidash.sourceforge.net/
************************************************************************************************/


// generated by Fast Light User Interface Designer (fluid) version 1.0110

#ifndef Dash_h
#define Dash_h
#include <FL/Fl.H>
extern bool QuitProgram; //Signal Quit button press -> runUI() to stop looping
extern bool QuitShowLic; //Signal Accept button press -> showLic() to stop looping
#include <FL/Fl_Double_Window.H>
extern Fl_Double_Window *main_window;
#include <FL/Fl_Group.H>
extern Fl_Group *run_group;
#include <FL/Fl_Button.H>
extern Fl_Button *go_button;
#include <FL/Fl_Choice.H>
extern Fl_Choice *run_type_choice;
extern Fl_Group *settings_group;
#include <FL/Fl_Input.H>
extern Fl_Input *OBDUSB_portname;
extern Fl_Button *set_OBDUSB_portname;
#include <FL/Fl_Output.H>
extern Fl_Output *log_filename;
extern Fl_Button *set_log_filename;
extern Fl_Output *csv_filename;
extern Fl_Button *set_csv_filename;
extern Fl_Button *convert_log_csv;
extern Fl_Choice *gas_vol_unit_choice;
extern Fl_Button *reset_ini_settings;
extern Fl_Choice *baud_rate_choice;
#include <FL/Fl_Value_Input.H>
extern Fl_Value_Input *fuel_cost_input;
extern Fl_Value_Input *odo_input;
extern Fl_Choice *gas_cost_unit_choice;
extern Fl_Choice *odo_unit_choice;
extern Fl_Value_Input *csv_every_sec;
#include <FL/Fl_Text_Display.H>
extern Fl_Button *about_button;
extern Fl_Menu_Item menu_run_type_choice[];
#define run_type_normal (menu_run_type_choice+0)
#define run_type_simulation (menu_run_type_choice+1)
extern Fl_Menu_Item menu_gas_vol_unit_choice[];
#define gas_vol_unit_usgal (menu_gas_vol_unit_choice+0)
#define gas_vol_unit_ukgal (menu_gas_vol_unit_choice+1)
#define gas_vol_unit_liter (menu_gas_vol_unit_choice+2)
extern Fl_Menu_Item menu_baud_rate_choice[];
#define baud_rate_2M (menu_baud_rate_choice+0)
#define baud_rate_1M (menu_baud_rate_choice+1)
#define baud_rate_500K (menu_baud_rate_choice+2)
#define baud_rate_115200 (menu_baud_rate_choice+3)
extern Fl_Menu_Item menu_gas_cost_unit_choice[];
#define gas_cost_unit_usgal (menu_gas_cost_unit_choice+0)
#define gas_cost_unit_ukgal (menu_gas_cost_unit_choice+1)
#define gas_cost_unit_liter (menu_gas_cost_unit_choice+2)
extern Fl_Menu_Item menu_odo_unit_choice[];
#define odo_unit_mile (menu_odo_unit_choice+0)
#define odo_unit_km (menu_odo_unit_choice+1)
#include "Fl_Gauge.H"
extern void go_button_CB(Fl_Button*, void*);

class Gauges {
public:
  Gauges();
  Fl_Double_Window *gauges_window;
  Fl_Gauge *iceT_G;
  Fl_Gauge *wT_G;
  Fl_Gauge *speed_G;
  Fl_Gauge *amp_G;
  Fl_Gauge *soc_G;
  Fl_Gauge *rpm_G;
  Fl_Gauge *ign_G;
  Fl_Gauge *hvV_G;
  Fl_Gauge *auxV_G;
  Fl_Gauge *dsc_G;
  Fl_Gauge *oaT_G;
  Fl_Gauge *intakeT_G;
  Fl_Gauge *atm_G;
  Fl_Gauge *inv1T_G;
  Fl_Gauge *inv2T_G;
  Fl_Gauge *mg1T_G;
  Fl_Gauge *mg2T_G;
  Fl_Gauge *cnvT_G;
  Fl_Gauge *blC_G;
  Fl_Gauge *buC_G;
  Fl_Gauge *catT1_G;
  Fl_Gauge *catT2_G;
  Fl_Gauge *rpm2_G;
  Fl_Gauge *mg1rpm_G;
  Fl_Gauge *mg2rpm_G;
  Fl_Output *clock_G;
  Fl_Gauge *psd_G;
  Fl_Button *go_button;
  Fl_Gauge *mpg_G;
  Fl_Gauge *dtcdist_G;
  Fl_Gauge *wT2_G;
  Fl_Gauge *odo_G;
  Fl_Gauge *timeDelta_G;
  Fl_Gauge *mpgmean_G;
  Fl_Gauge *fuel_G;
  Fl_Gauge *load_G;
  Fl_Gauge *acc_G;
  Fl_Gauge *aLR_G;
  Fl_Output *shift_G;
  Fl_Output *light_G;
  Fl_Output *door_G;
  Fl_Gauge *trip_G;
  Fl_Gauge *kW_G;
  Fl_Gauge *eff_G;
  Fl_Gauge *eff2_G;
  Fl_Gauge *kW2_G;
  Fl_Gauge *gal_G;
  Fl_Gauge *dhvBV_G;
  Fl_Gauge *hvFanV_G;
  Fl_Gauge *cost_G;
  Fl_Gauge *gph_G;
  void show();
};
extern Fl_Double_Window *about_window;
#include <FL/Fl_Scroll.H>
extern Fl_Text_Display *about_textdisplay;
extern Fl_Button *accept_button;
extern Fl_Output *homepage_txt;
Fl_Double_Window* make_about_window();
#endif
